
class Vector {
private:
	double * v;
	int size;
	bool horiz;

public:
	~Vector() { FREE(v); }
	Vector() { v=NULL; }
	Vector(int s, bool h) { v=(double*)malloc(sizeof(double)*s); size=s; horiz=h; }
	void init(int s, bool h) { if ( v ) FREE(v); v=(double*)malloc(sizeof(double)*s); size=s; horiz=h; }
	
	void disp() { for ( int p=0; p<size; p++ ) { printf("% 6.5f ", v[p]); if ( !horiz ) printf("\n"); } if ( horiz ) printf("\n"); }
	double & operator[] (int p) { return v[p-1]; }
};

class Matrix {
private:
	double * im;
	int imheight;
	int imwidth;

public:
	~Matrix() { if ( im ) FREE(im); }
	Matrix() { im=NULL; }
	Matrix(int h, int w) { im=(double*)malloc(sizeof(double)*w*h); imheight=h; imwidth=w; }
	void init(int h, int w) { if ( im ) FREE(im); im=(double*)malloc(sizeof(double)*w*h); imheight=h; imwidth=w; }
	
	void disp();
	int height() { return imheight; }
	int width() { return imwidth; }
	double e(int y, int x) { return *(im+((y-1)*imwidth)+(x-1)); }

	double set(int y, int x, double val) { *(im+((y-1)*imwidth)+(x-1))=val; return val; }

	Matrix & operator = (Matrix &m2);
};

void Matrix::disp()
{
	int y, x;

	for(y=0; y<imheight; y++) {
		for(x=0; x<imwidth; x++) {
			printf("% 6.5f ", *(im+(y*imwidth)+x));
		}
		printf("\n");
	}
}

Matrix & Matrix::operator = (Matrix &m2)
{
	if ( im ) FREE(im);

	imheight=m2.height();
	imwidth=m2.width();

	im=(double*)malloc(sizeof(double)*imheight*imwidth);

	int y, x;

	for(y=0; y<imheight; y++) {
		for(x=0; x<imwidth; x++) {
			*(im+(y*imwidth)+x)=m2.e(y+1, x+1);
		}
	}

	return *this;
}
